package de.uni.leipzig.informatik.pacosy.datastructure.dao.factory;

import de.uni.leipzig.informatik.pacosy.datastructure.api.factory.ICophylogenyFactory;
import de.uni.leipzig.informatik.pacosy.datastructure.dao.Association;
import de.uni.leipzig.informatik.pacosy.datastructure.dao.Tanglegramm;

public class CophylogenyFactory implements ICophylogenyFactory {

	private static CophylogenyFactory singleton;
	
	private CophylogenyFactory(){}
	
	public static CophylogenyFactory getSingleton(){
		if (singleton == null){
			singleton = new CophylogenyFactory();
		}
		return singleton;
	}
	
	@Override
	public Tanglegramm createTanglegramm() {
		return new Tanglegramm();
	}

	@Override
	public Association createAssociation() {
		return new Association();
	}

	@Override
	public Object createObject(String objectName) {
		if (objectName.equalsIgnoreCase("Tangelegramm")){
			return new Tanglegramm();
		} else if (objectName.equalsIgnoreCase("Association")){
			return new Association();
		} else {
			return null;
		}
	}

}
