package de.uni.leipzig.informatik.pacosy.nexus.block;

import java.util.ArrayList;
import java.util.List;

import de.uni.leipzig.informatik.pacosy.nexus.block.parser.NexusTaxaBlockParser;
import de.uni.leipzig.informatik.pacosy.nexus.command.NexusCommand;
import de.uni.leipzig.informatik.pacosy.nexus.command.NexusEquationStyleCommand;
import de.uni.leipzig.informatik.pacosy.nexus.command.NexusListOfStringsStyleCommand;


public class NexusTaxaBlock extends NexusBlock {

	private int dimensions;
	private List<String> taxlabels;
	
	@Override
	protected void initialize(){
		this.taxlabels = new ArrayList<String>();
		setBlockParser(NexusTaxaBlockParser.getSingleton());
	}
	
	@Override
	public void read(NexusBlock rawBlock, java.util.Map<String,NexusBlock> blocks) throws de.uni.leipzig.informatik.pacosy.nexus.exception.NexusFormatException {
		super.read(rawBlock, blocks);
		for (NexusCommand command : getCommands()) {
			if (command.getCommandName().equalsIgnoreCase("DIMENSIONS")
					&& command instanceof NexusEquationStyleCommand) {
				this.dimensions = Integer
						.parseInt(((NexusEquationStyleCommand) command)
								.getRightHandSide());
			} else if (command.getCommandName().equalsIgnoreCase("TAXLABELS")
					&& command instanceof NexusListOfStringsStyleCommand) {
				this.taxlabels = ((NexusListOfStringsStyleCommand) command)
						.getList();
			}
		}
	}

	public int getDimensions(){
		return this.dimensions;
	}
	
	public List<String> getTaxlabels(){
		return this.taxlabels;
	}
}
