package de.uni.leipzig.informatik.pacosy.nexus.block.parser;

import java.util.List;
import java.util.Map;

import de.uni.leipzig.informatik.pacosy.datastructure.api.factory.IDaoFactory;
import de.uni.leipzig.informatik.pacosy.nexus.block.NexusBlock;
import de.uni.leipzig.informatik.pacosy.nexus.command.NexusCommand;
import de.uni.leipzig.informatik.pacosy.nexus.command.parser.INexusCommandParser;
import de.uni.leipzig.informatik.pacosy.nexus.exception.NexusFormatException;

public interface INexusBlockParser {

	public void registerCommandParser(String id, INexusCommandParser commandParser);
	public void unregisterCommandParser(String id);
	public INexusCommandParser getNexusCommandParser(String id);
	public IDaoFactory getDaoFactory();
	public void setDaoFactory(IDaoFactory daoFactory);
	public List<NexusCommand> deserializeCommands(NexusBlock rawBlock, Map<String, NexusBlock> blocks) throws NexusFormatException;
}
