package de.uni.leipzig.informatik.pacosy.nexus.command.parser;

import java.util.List;
import java.util.Map;

import de.uni.leipzig.informatik.pacosy.datastructure.api.factory.IDaoFactory;
import de.uni.leipzig.informatik.pacosy.nexus.block.NexusBlock;
import de.uni.leipzig.informatik.pacosy.nexus.command.NexusCommand;
import de.uni.leipzig.informatik.pacosy.nexus.exception.NexusFormatException;

public class DefaultNexusCommandParser implements INexusCommandParser {

	private static DefaultNexusCommandParser singleton;
	
	public static DefaultNexusCommandParser getSingleton(){
		if (singleton == null){
			singleton = new DefaultNexusCommandParser();
		}
		return singleton;
	}

	private IDaoFactory daoFactory;
	
	protected DefaultNexusCommandParser(){}
	
	@Override
	public IDaoFactory getDaoFactory() {
		return this.daoFactory;
	}

	@Override
	public void setDaoFactory(IDaoFactory daoFactory){
		this.daoFactory = daoFactory;
	}

	@Override
	public NexusCommand deserialize(NexusCommand rawCommand, List<NexusCommand> commands, Map<String, NexusBlock> blocks) throws NexusFormatException {
		return rawCommand;
	}

}
