package de.uni.leipzig.informatik.pacosy.nexus.command.parser;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import de.uni.leipzig.informatik.pacosy.nexus.Token;
import de.uni.leipzig.informatik.pacosy.nexus.block.NexusBlock;
import de.uni.leipzig.informatik.pacosy.nexus.command.NexusCommand;
import de.uni.leipzig.informatik.pacosy.nexus.command.NexusListOfStringsStyleCommand;
import de.uni.leipzig.informatik.pacosy.nexus.exception.NexusFormatException;

public class NexusListOfStringsStyleCommandParser extends
		DefaultNexusCommandParser {
	
	protected static NexusListOfStringsStyleCommandParser singleton;
	
	public static NexusListOfStringsStyleCommandParser getSingleton(){
		if (singleton == null){
			singleton = new NexusListOfStringsStyleCommandParser();
		}
		return singleton;
	}
	
	private NexusListOfStringsStyleCommandParser() {}
	
	@Override
	public NexusCommand deserialize(NexusCommand rawCommand, List<NexusCommand> commands, Map<String, NexusBlock> blocks) throws NexusFormatException {
		List<String> list = new ArrayList<String>();
		for (Token token : rawCommand.getTokens()) {
			if (!token.isComment()) {
				list.add(token.getValue());
			}
		}
		return new NexusListOfStringsStyleCommand(rawCommand, list);
	}

}
