package de.uni.leipzig.informatik.pacosy.nexus.command.parser;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import de.uni.leipzig.informatik.pacosy.nexus.Token;
import de.uni.leipzig.informatik.pacosy.nexus.block.NexusBlock;
import de.uni.leipzig.informatik.pacosy.nexus.command.NexusCommand;
import de.uni.leipzig.informatik.pacosy.nexus.command.NexusMapOfStringsStyleCommand;
import de.uni.leipzig.informatik.pacosy.nexus.exception.NexusFormatException;

public class NexusMapOfStringsStyleCommandParser extends
		DefaultNexusCommandParser {

	protected static NexusMapOfStringsStyleCommandParser singleton;
	
	public static NexusMapOfStringsStyleCommandParser getSingleton(){
		if (singleton == null){
			singleton = new NexusMapOfStringsStyleCommandParser();
		}
		return singleton;
	}
	
	private NexusMapOfStringsStyleCommandParser() {}
	
	@Override
	public NexusCommand deserialize(NexusCommand rawCommand, List<NexusCommand> commands, Map<String, NexusBlock> blocks) throws NexusFormatException {
		Map<String, String> map = new HashMap<String, String>();
		Iterator<Token> iterator = rawCommand.getTokens().iterator();
		String key = "";
		String value = "";
		Token token = null;
		while (iterator.hasNext()) {
			token = iterator.next();
			if (!token.isComment()) {
				if (!token.getValue().equals(",")) {
					if (key.equals("")) {
						key = token.getValue();
					} else if (value.equals("")) {
						value = token.getValue();
					} else {
						throw new NexusFormatException(
								"',' sign expected at " + token.getPosition());
					}
				} else if (!key.equals("")) {
					if (!value.equals("")) {
						map.put(key, value);
						key = "";
						value = "";
					} else {
						throw new NexusFormatException(
								"string token expected at " + token.getPosition());
					}
				} else {
					throw new NexusFormatException(
							"string token expected at " + token.getPosition());
				}
			}
		}
		if (!key.equals("")) {
			if (!value.equals("")) {
				map.put(key, value);
			} else {
				throw new NexusFormatException(
						"string token expected after token at " + token.getPosition());
			}
		}
		return new NexusMapOfStringsStyleCommand(rawCommand, map);
	}

}
